#ifndef DISK_H_INCLUDED
#define DISK_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "d88.h"
#include "ini.h"

#define	MAXDRV	4	// őhCuڑ



// u^Cv
enum UnitType
{
	PC6031 = 0,
	PC6031SR,
	PC8031,
	PC80S31,
	PC6601,
	PC6601SR,
	EndofUnitType
};

// hCu^Cv
enum FddType
{
	FDD1D = 0,
	FDD1DD,
	FDD2D,
	FDD2DD,
	
	EndofFddType
};

// R}h
// PC-6031(т񒲍x[X)
enum FddCommand
{
	INITIALIZE			= 0x00,
	WRITE_DATA			= 0x01,
	READ_DATA			= 0x02,
	SEND_DATA			= 0x03,
	FORMAT				= 0x05,
	SEND_RESULT_STATUS	= 0x06,
	SEND_DRIVE_STATUS	= 0x07,
	
	COPY				= 0x04,	// PC-6031SR
	GET_MEMORY			= 0x0b,	// PC-6031SR
	FAST_WRITE_DISK		= 0x11,	// PC-6031SR
	FAST_SEND_DATA		= 0x12,	// PC-6031SR
	SET_MODE			= 0x17,	// PC-6031SR
	
	IDLE				= 0xff,	// ҂̏
	EndofFddCmd
};

// ~jtbs[fBXN e
struct DISK60 {
	FddType Type;		// hCu^Cv
	
	bool PD_ATN;		// Attention		:P6->FDD 1=R}hM 0=f[^M
	bool PD_DAC;		// Data Accepted	:P6->FDD f[^M
	bool PD_RFD;		// Ready For Data	:P6->FDD f[^M
	bool PD_DAV;		// Data Valid		:P6->FDD f[^M
	
	bool DP_DAC;		// Data Accepted	:FDD->P6 f[^M
	bool DP_RFD;		// Ready For Data	:FDD->P6 f[^M
	bool DP_DAV;		// Data Valid		:FDD->P6 f[^M
	
	int command;		// 󂯎R}h
	int step;			// p[^͑҂Xe[^X
	
	int blk;			// ]ubN
	int drv;			// hCuԍ-1
	int trk;			// gbNԍ
	int sct;			// ZN^ԍ
	
	int rsize;			// Ǎ݃obt@̃f[^
	int wsize;			// ݃obt@̃f[^
	int ridx;
	
	int size;			// oCg
	
	bool Fast;			// ANZXtO true:L false:
	bool FastStat;		// ANZXANZXf[^tO true:2oCg false:1oCg
	
	BYTE retdat;		// port D0H Ԃl
	
	BYTE busy;			// hCuBUSY 1:hCu1 2:hCu2
	
	bool error;			// G[tO true:G[ false:G[Ȃ
	
	DISK60() :
		Type(FDD1D),
		PD_DAC(false), PD_RFD(false), PD_DAV(false), PD_ATN(false),
		DP_DAC(false), DP_RFD(false), DP_DAV(false),
		command(IDLE), step(0),
		blk(0), drv(0), trk(0), sct(0),
		size(0), Fast(false), FastStat(false),
		retdat(0xff), busy(0), error(false) {}
};


enum FdcPhase {
	IDLEP = 0,
	C_PHASE,
	E_PHASE,
	R_PHASE
};

enum FdcSeek{
	SK_STOP = 0,	// V[NȂ
	SK_SEEK,		// V[N
	SK_END			// V[N
};

struct PD765 {
	BYTE command;		// R}h
	
//	FdcPhase phase;		// Phase (C/E/R)
//	int step;			// Phasȅ菇
	
	BYTE SRT;			// Step Rate Time
	BYTE HUT;			// Head Unloaded Time
	BYTE HLT;			// Head Load Time
	bool ND;			// Non DMA Mode  true:Non DMA false:DMA
	
	FdcSeek SeekSta[4];	// V[N
	BYTE NCN[4];		// New Cylinder Number
	BYTE PCN[4];		// Present Cylinder Number
	
	
	BYTE MT;			// Multi-track
	BYTE MF;			// MFM/FM Mode
	BYTE SK;			// Skip
	BYTE HD;			// Head
	BYTE US;			// Unit Select
	
	BYTE C;				// Cylinder Number
	BYTE H;				// Head Address
	BYTE R;				// Record
	BYTE N;				// Number
	BYTE EOT;			// End of Track
	BYTE GPL;			// Gap Length
	BYTE DTL;			// Data length
	
	BYTE D;				// Format Data
	BYTE SC;			// Sector
	
	BYTE ST0;			// ST0
	BYTE ST1;			// ST1
	BYTE ST2;			// ST2
	BYTE ST3;			// ST3
	
	BYTE Status;		// Status
	bool Intr;			// FDCݔtO
	
		PD765() :
		command(0), // phase(R_PHASE), step(0),
		SRT(32), HUT(0), HLT(0), ND(false),
		MT(0), MF(0), SK(0), HD(0), US(0), C(0), H(0), R(0), N(0),
		EOT(0), GPL(0), DTL(0),
		ST0(0), ST1(0), ST2(0), ST3(0), Status(0), Intr(false)
		{
			INITARRAY( SeekSta, SK_STOP );
			INITARRAY( NCN, 0 );
			INITARRAY( PCN, 0 );
		}
};


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSK6 : public Device, public IDoko {
protected:
	UnitType UType;						// u^Cv
	int DrvNum;							// hCu
	char FilePath[MAXDRV][PATH_MAX];	// t@CpX
	cD88 *Dimg[MAXDRV];					// fBXNC[WIuWFNgւ̃|C^
	bool Sys[MAXDRV];					// VXefBXNtO
	bool DDDrv[MAXDRV];					// 1DDhCutO
	int waitcnt;						// EFCgJE^
	bool waiten;						// EFCgLtO
	
	void ResetWait();					// EFCgJE^Zbg
	void AddWait( int );				// EFCgJE^Z
	bool SetWait( int, int=0 );			// EFCgݒ
	
public:
	DSK6( VM6 *, const ID& );			// RXgN^
	virtual ~DSK6();					// fXgN^
	
	virtual void EventCallback( int, int );	// CxgR[obN֐
	
	virtual bool Init( int ) = 0;		// 
	virtual void Reset() = 0;			// Zbg
	
	bool Mount( int, const char * );	// DISK }Eg
	void Unmount( int );				// DISK A}Eg
	
	int GetDrives();					// hCu擾
	
	bool IsMount( int ) const;			// }Egς?
	bool IsSystem( int ) const;			// VXefBXN?
	bool IsProtect( int ) const;		// veNg?
	virtual bool InAccess( int ) const = 0;	// ANZX?
	
	const char *GetFile( int ) const;	// t@CpX擾
	const char *GetName( int ) const;	// DISK擾
	
	void WaitEnable( bool );			// EFCgLtOݒ
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class DSK60 : public DSK6 {
protected:
	DISK60 mdisk;			// ~jtbs[fBXNe
	
	BYTE RBuf[4096];		// Ǎ݃obt@
	BYTE WBuf[4096];		// ݃obt@
	
	BYTE io_D1H;
	
	BYTE FddIn();			// DISKjbg̃f[^ 		(port D0H)
	void FddOut( BYTE );	// DISKjbgւ̃R}hCf[^o (port D1H)
	BYTE FddCntIn();		// DISKjbg̐M 		(port D2H)
	void FddCntOut( BYTE );	// DISKjbgւ̐Mo 		(port D3H)
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutD1H( int, BYTE );
	void OutD2H( int, BYTE );
	void OutD3H( int, BYTE );
	BYTE InD0H( int );
	BYTE InD1H( int );
	BYTE InD2H( int );
	
public:
	DSK60( VM6 *, const ID& );			// RXgN^
	virtual ~DSK60();					// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int );					// 
	void Reset();						// Zbg
	bool InAccess( int ) const;			// ANZX?
	
	// foCXID
	enum IDOut{ outD1H=0, outD2H, outD3H };
	enum IDIn {  inD0H=0,  inD1H,  inD2H };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class DSK64 : public DSK60 {
public:
	DSK64( VM6 *, const ID& );			// RXgN^
	virtual ~DSK64();					// fXgN^
};


class DSK66 : public DSK6 {
private:
	struct CmdBuffer {
		BYTE Data[10];
		int Index;
		
		CmdBuffer() : Index(0) { *Data = 0; }
	};
	
	BYTE FDDBuf[1024];					// FDDobt@
	void BufWrite( int, BYTE );			// FDDobt@
	BYTE BufRead( int );				// FDDobt@Ǎ
	
	CmdBuffer CmdIn;					// R}hobt@
	CmdBuffer CmdOut;					// Xe[^Xobt@
	
	// FDC
	PD765 fdc;
	
	// FDCI
	int SendBytes;						// ](256BytesP)
	bool ExtDrv;						// FDD^Cv true: Ot false: 
	bool B2Dir;							// PortB2H ANZXWX^ true: o false: 
	
	void PushStatus( BYTE );			// Xe[^Xobt@Ƀf[^
	BYTE PopStatus();					// Xe[^Xobt@f[^o
	
	void OutFDC( BYTE );				// FDC ɏ
	BYTE InFDC();						// FDC Ǎ
	void Exec();						// FDC R}hs
	
	bool SearchSector( BYTE * );		// ZN^T
	
	void ReadDiagnostic();				// Read Diagnostic
	void Specify();						// Specify
	void ReadData();					// Read Data
	void WriteData();					// Write Data
	void Recalibrate();					// Recalibrate
	void Seek();						// Seek
	void SenseInterruptStatus();		// Sense Interrupt Status
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB1H( int, BYTE );	// FDCI[hݒ
	void OutB3H( int, BYTE );	// PortB2h̓o͐
	void OutD0H( int, BYTE );	// Buffer
	void OutD1H( int, BYTE );	// Buffer
	void OutD2H( int, BYTE );	// Buffer
	void OutD3H( int, BYTE );	// Buffer
	void OutD6H( int, BYTE );	// FDD[^
	void OutD8H( int, BYTE );	// ݕ⏞ ???
	void OutDAH( int, BYTE );	// ]ʎw
	void OutDDH( int, BYTE );	// FDC f[^WX^
	void OutDEH( int, BYTE );	// ?
	
	BYTE InB2H( int );			// FDC INT
	BYTE InD0H( int );			// Buffer
	BYTE InD1H( int );			// Buffer
	BYTE InD2H( int );			// Buffer
	BYTE InD3H( int );			// Buffer
	BYTE InD4H( int );			// FDD[^̏
	BYTE InDCH( int );			// FDC Xe[^XWX^
	BYTE InDDH( int );			// FDC f[^WX^

public:
	DSK66( VM6 *, const ID& );			// RXgN^
	~DSK66();							// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int );					// 
	void Reset();						// Zbg
	bool InAccess( int ) const;			// ANZX?
	
	// foCXID
	enum IDOut{ outB1H=0, outB3H, outD0H, outD1H, outD2H, outD3H, outD6H, outD8H,
				outDAH,   outDDH, outDEH };
	enum IDIn {  inB2H=0,  inD0H,  inD1H,  inD2H,  inD3H,  inD4H,  inDCH,  inDDH };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class DSK68 : public DSK66 {
public:
	DSK68( VM6 *, const ID& );			// RXgN^
	virtual ~DSK68();					// fXgN^
};

#endif	// DISK_H_INCLUDED
