#ifndef PSGFM_H_INCLUDED
#define PSGFM_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "sound.h"
#include "device/ay8910.h"
#include "device/ym2203.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// PSGnTEhfoCX̃x[XNX
class PSGb : public Device, public SndDev, public virtual IDoko {
protected:
	BYTE JoyNo;							// ǎWCXeBbN̔ԍ(0-1)
	int Clock;							// NbN
	
	int GetUpdateSamples();				// XVTv擾
	
public:
	PSGb( VM6 *, const ID& );			// RXgN^
	virtual ~PSGb();					// fXgN^
	
	virtual bool Init( int, int ) = 0;	// 
	virtual void Reset(){};				// Zbg
	
	virtual void EventCallback( int, int );		// CxgR[obN֐
	virtual bool SetSampleRate( int, int ) = 0;	// TvO[gݒ
};


class PSG6 : public PSGb, public cAY8910 {
protected:
	void PreWriteReg();					// WX^ύXÕXg[XV
	
	// |[gANZX֐(WCXeBbN)
	BYTE PortAread();
	void PortBwrite( BYTE );
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutA0H( int, BYTE );			// PSGWX^AhXb`
	void OutA1H( int, BYTE );			// PSGCgf[^
	void OutA3H( int, BYTE );			// PSGCANeBu
	BYTE InA2H( int );					// PSG[hf[^
	
public:
	PSG6( VM6 *, const ID& );			// RXgN^
	virtual ~PSG6();					// fXgN^
	
	bool Init( int, int );				// 
	
	bool SetSampleRate( int, int );		// TvO[gݒ
	
	int SoundUpdate( int );				// Xg[XV
	
	// foCXID
	enum IDOut{ outA0H=0, outA1H, outA3H };
	enum IDIn {  inA2H=0 };
	
	// ------------------------------------------
	bool DokoSave( cIni * );	// ǂłSAVE
	bool DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class OPN6 : public PSGb, public cYM2203 {
protected:
	void PreWriteReg();					// WX^ύXÕXg[XV
	
	void SetTimerA( int );				// TimerAݒ
	void SetTimerB( int );				// TimerBݒ
	
	// |[gANZX֐(WCXeBbN)
	BYTE PortAread();
	void PortBwrite( BYTE );
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	void OutA0H( int, BYTE );			// OPNWX^AhXb`
	void OutA1H( int, BYTE );			// OPNCgf[^
	void OutA3H( int, BYTE );			// OPNCANeBu
	BYTE InA2H( int );					// OPN[hf[^
	BYTE InA3H( int );					// OPNXe[^X[h
	
public:
	OPN6( VM6 *, const ID& );			// RXgN^
	~OPN6();							// fXgN^
	
	bool Init( int, int );				// 
	
	void EventCallback( int, int );		// CxgR[obN֐
	bool SetSampleRate( int, int );		// TvO[gݒ
	
	int SoundUpdate( int );				// Xg[XV
	
	// foCXID
	enum IDOut{ outA0H=0, outA1H, outA3H };
	enum IDIn {  inA2H=0,  inA3H };
};


#endif	// PSGFM_H_INCLUDED
