#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "typedef.h"
#include "device.h"
#include "ini.h"
#include "p6t2.h"
#include "sound.h"


// f[^̎
#define PG_P	(0x0000)
#define PG_S	(0x0100)
#define PG_D	(0x0200)


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class CMTL : public Device, public SndDev, public IDoko {
private:
	char FilePath[PATH_MAX];			// TAPEt@CtpX
	cP6T *p6t;
	bool Relay;							// [̏
	bool stron;							// Xg[p
	
	bool Boost;							// BoostUpg? true:g false:gȂ
	int MaxBoost60;						// BoostUp ő{(N60[h)
	int MaxBoost62;						// BoostUp ő{(N60m/N66[h)
	
	bool Remote( bool );				// [g(PLAY,STOP)
	WORD CmtRead();						// CMT 1Ǎ
	int GetSinCurve( int );				// sing擾
	
	// foCX`
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/OANZX֐
	void OutB0H( int, BYTE );
	
public:
	CMTL( VM6 *, const ID& );			// RXgN^
	virtual ~CMTL();					// fXgN^
	
	void EventCallback( int, int );		// CxgR[obN֐
	
	bool Init( int );					// 
	void Reset();						// Zbg
	
	bool Mount( const char * );			// TAPE }Eg
	void Unmount();						// TAPE A}Eg
	
	WORD Update();						// Xg[XV(1byte)
	int SoundUpdate( int );				// Xg[XV
	
	bool IsMount() const;				// }Egς?
	bool IsAutoStart() const;			// I[gX^[g?
	
	const char *GetFile() const;		// t@CpX擾
	const char *GetName() const;		// TAPE擾
	DWORD GetSize() const;				// x^C[WTCY擾
	int GetCount() const;				// JE^擾
	bool IsRelay() const;				// [̏Ԏ擾
	
	void SetBoost( bool );				// BoostUpݒ
	void SetMaxBoost( int, int );		// BoostUpő{ݒ
	bool IsBoostUp() const;				// BoostUpԎ擾
	
	const P6TAUTOINFO *GetAutoStartInfo() const;	// I[gX^[g擾
	
	// foCXID
	enum IDOut{ outB0H=0 };
	enum IDIn {};
	
	// ------------------------------------------
	bool DokoSave( cIni * );		// ǂłSAVE
	bool DokoLoad( cIni * );		// ǂłLOAD
	// ------------------------------------------
};


class CMTS : public Device {
private:
	char FilePath[PATH_MAX];			// TAPEt@CtpX
	
	FILE *fp;							// FILE |C^
	int Baud;							// {[[g
	
public:
	CMTS( VM6 *, const ID& );			// RXgN^
	~CMTS();							// fXgN^
	
	bool Init( const char * );			// 
	
	bool Mount();						// TAPE }Eg
	void Unmount();						// TAPE A}Eg
	
	void SetBaud( int );				// {[[gݒ
	
	void CmtWrite( BYTE );				// CMT 1
};


#endif	// TAPE_H_INCLUDED
